/* GCC */
#include <iostream>
#include <stdio.h>

using namespace std;

#define MAXN 600

char str[MAXN];
int A[MAXN][MAXN];
int n, k=0;

void pomet(int a, int b)
{
    A[a][b] = k;
    if ((a>0) && (A[a-1][b] == -1)) pomet(a-1, b);
    if ((a<n) && (A[a+1][b] == -1)) pomet(a+1, b);
    if ((b>0) && (A[a][b-1] == -1)) pomet(a, b-1);
    if ((b<n) && (A[a][b+1] == -1)) pomet(a, b+1);
}

bool neravno(int x1, int y1, int x2, int y2)
{
    if (((x1 == x2) && (y1 == y2)) ||
        ((x1 != x2) && (y1 != y2)))
        return false;
    else
        return true;
}

bool equalent(int a, int b)
{
    int i, j;
    int hmin1=n, hmax1=0, hmin2=n, hmax2=0;
    int vmin1=n, vmax1=0, vmin2=n, vmax2=0;

    for (i=0; i<n; i++)
        for (j=0; j<n; j++){
            if (A[i][j] == a){
                if (i < hmin1) hmin1 = i;
                if (i > hmax1) hmax1 = i;
                if (j < vmin1) vmin1 = j;
                if (j > vmax1) vmax1 = j;
            }
            if (A[i][j] == b){
                if (i < hmin2) hmin2 = i;
                if (i > hmax2) hmax2 = i;
                if (j < vmin2) vmin2 = j;
                if (j > vmax2) vmax2 = j;
            }
        }
    int h1 = hmax1-hmin1+1, h2 = hmax2-hmin2+1;
    int v1 = vmax1-vmin1+1, v2 = vmax2-vmin2+1;
    int h, v;
    bool bol=true;
    if ((h1 == h2) && (v1 == v2)){
        h = h1; v = v1;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmin1+i][vmin1+j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
        bol=true;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmin1+i][vmax1-j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
        bol=true;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmax1-i][vmin1+j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
        bol=true;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmax1-i][vmax1-j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
    }
    if ((h1 == v2) && (v1 == h2)){
        h = h1; v = v1;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmin1+i][vmin1+j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
        bol=true;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmin1+i][vmax1-j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
        bol=true;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmax1-i][vmin1+j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
        bol=true;
        for (i=0; i<h; i++){
            for (j=0; j<v; j++){
                if (neravno(A[hmax1-i][vmax1-j], A[hmin2+i][vmin2+j], a, b)){
                    bol = false;
                    break;
                }
            }
            if (!bol) break;
        }
        if (bol) return true;
    }

    return false;
}

int main(void)
{
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);

    int i, j;
    gets(str);
    sscanf(str, "%d", &n);
    for (i=0; i<n; i++){
        gets(str);
        for (j=0; j<n; j++)
            if (str[j] == ' ')
                A[i][j] = 0;
            else
                A[i][j] = -1;
    }

    for (i=0; i<n; i++)
        for (j=0; j<n; j++)
            if (A[i][j] == -1){
                k++;
                pomet(i, j);
            }

    printf("%d ", k);
/*
    printf("\n");
    for (i=0; i<n; i++){
        for (j=0; j<n; j++)
            printf("%d ", A[i][j]);
        printf("\n");
    }
*/
    int k2 = k;
    for (i=1; i<=k2; i++)
        for (j=i+1; j<=k2; j++)
            if (equalent(i, j))
                k--;

    printf("%d\n", k);

    return 0;
}
