/* GCC */
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>
using namespace std;

int main(){
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
    int n;
    scanf("%d", &n);

    char A[n+2][n+2];
    memset(A, 0, sizeof(A));
    char ch;

    for (int i=1; i<=n; i++){
        scanf("%c", &ch);
        for (int j=1; j<=n; j++){
            scanf("%c", &ch);
            if (ch != ' ') A[i][j] = 1;
        }
    }
    /*for (int i=0; i<=n+1; i++){
        for (int j=0; j<=n+1; j++){
            printf("%d", A[i][j]);
        }
        printf("\n");
    }*/

    vector <pair<int,int> > D;
    vector <pair<pair<int,int>, pair<int,int> > > Fig; Fig.clear();
    vector <vector <vector <int> > > P;
    int k = 1,p1,p2,minx,miny,maxx,maxy;

    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            if (A[i][j] == 1){
                minx = maxx = j;
                miny = maxy = i;;
                k++; A[i][j] = k;
                D.clear();
                D.push_back(make_pair(i,j));
                for (int ii=0; ii<D.size(); ii++){
                    p1 = D[ii].first;
                    p2 = D[ii].second;
                    if (A[p1-1][p2] == 1) {A[p1-1][p2] = k; D.push_back(make_pair(p1-1,p2));}
                    if (A[p1+1][p2] == 1) {A[p1+1][p2] = k; D.push_back(make_pair(p1+1,p2));}
                    if (A[p1][p2-1] == 1) {A[p1][p2-1] = k; D.push_back(make_pair(p1,p2-1));}
                    if (A[p1][p2+1] == 1) {A[p1][p2+1] = k; D.push_back(make_pair(p1,p2+1));}

                    if (p2<minx) minx = p2;
                    if (p2>maxx) maxx = p2;
                    if (p1<miny) miny = p1;
                    if (p1>maxy) maxy = p1;
                }
                Fig.push_back(make_pair(make_pair(minx,miny), make_pair(maxx,maxy)));
            }
        }
    }
    printf("%d ", k-1);
    /*for (int i=0; i<k-1; i++){
        printf("%d %d %d %d\n", Fig[i].first.first, Fig[i].first.second, Fig[i].second.first, Fig[i].second.second);
    }*/

    P.resize(k-1);
    for (int i=0; i<k-1; i++) P[i].resize(Fig[i].second.second-Fig[i].first.second+1);

    for (int kk=0; kk<k-1; kk++){
        minx = Fig[kk].first.first;
        miny = Fig[kk].first.second;
        maxx = Fig[kk].second.first;
        maxy = Fig[kk].second.second;
        for (int i=miny; i<=maxy; i++){
            for (int j=minx; j<maxx; j++){
                if (A[i][j] == kk+2) P[kk][i-miny].push_back(1);
                else P[kk][i-miny].push_back(0);
            }
        }
        //P[kk] = Ch[P[kk]];
    }

    /*for (int kk=0; kk<k-1; kk++){
        for (int i=0; i<P[kk].size(); i++){
            for (int j=0; j<P[kk][i].size(); j++){
                printf("%d", P[kk][i][j]);
            }
            printf("\n");
        }
        printf("\n");
    }*/
    sort(P.begin(), P.end());
    P.erase(unique(P.begin(),P.end()), P.end());
    printf("%d\n", P.size());


    fclose(stdin);
    fclose(stdout);
    return 0;
}

